/*****************************************************************
 Project Name: Terminal Tetris
 File Name: common.c
 Description: Ʈ ⺻Լ.

 Created: 2004. 12. 22
 RCS-ID: $Id: common.c,v 1.61 2004/06/18 06:28:14 myunggoni Exp $
 Copyright: (c) 2004 by myunggoni
 License: GNU General Public License
 Author: Myung-Gon, Park <myunggoni@users.kldp.net>
 ******************************************************************/

#include <ncurses.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <errno.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <signal.h>
#include "blocks.h"
#include "main.h"
#include "config.h"

char board[MAX_HEIGHT][MAX_WIDTH];
int score;
int level;
int start_game;
static int cur_blocks_x;
static int cur_blocks_y;
static int cur_blocks_type;
static int cur_blocks_state;
static int next_blocks_type = -1;
static int whole_deleted_lines;
extern int network_game;
extern int sock;

void init_board() {
	int i, j;

	/* 带 ʱȭ Ѵ. */
	for(i = 0; i < MAX_HEIGHT; i++) {
		for(j = 0; j < MAX_WIDTH; j++) {
			board[i][j] = 0;
		}
		board[i][0] = 1; /* . */
		board[i][j - 1] = 1; /* . */
	}

	for(i = 0; i < MAX_WIDTH; i++)
		board[MAX_HEIGHT - 1][i] = 1;
}

void create_random_blocks() {
	cur_blocks_x = START_BLOCKS_X;
	cur_blocks_y = START_BLOCKS_Y;
	cur_blocks_state = 0;
	cur_blocks_type = next_blocks_type;
	next_blocks_type = rand() % 7;

	if(cur_blocks_type == -1)
		cur_blocks_type = rand() % 7;

	if(check_collision()) {
		score -= level * 50;
		start_game = 0;
	} else {
		draw_cur_blocks();
	}

}
	
void preview_blocks() {
	int i, j;
	
	mvprintw(PREVIEW_Y - 1, PREVIEW_X, "[Next]");
	
	for(i = 0; i < 2; i++) { /* ̸ ̺  ʱȭ. */
		for(j = 0; j < 4; j++) {
			mvaddch(PREVIEW_Y + i + 1, PREVIEW_X + j + 2, ' ');
		}
	}

	if(next_blocks_type >= 0 && next_blocks_type <= 6) { /*  ׸. */
		for(i = 0; i < 2; i++) {
			for(j = 0; j < 4; j++) {
				if(blocks[next_blocks_type][0][i][j] > 0) {
					mvaddch(PREVIEW_Y + i + 1, PREVIEW_X + j + 2, '*');
				}
			}
		}
	}

	for(i = 0; i < 4; i++) { /* ̸ ̺ ׸. */
		for(j = 0; j < 9; j++) {
			if(i == 0 || i == 3)
				if(j == 0 || j == 8)
					mvaddch(PREVIEW_Y + i, PREVIEW_X + j, '+');
				else
					mvaddch(PREVIEW_Y + i, PREVIEW_X + j, '-');
			else if(j == 0 || j == 8)
					mvaddch(PREVIEW_Y + i, PREVIEW_X + j, '|');
				
		}
	}
}

int check_collision() {
	int i, j;

	for(i = 0; i < 4; i++) {
		for(j = 0; j < 4; j++) {
			if(board[cur_blocks_y + i][cur_blocks_x + j] > 0 && blocks[cur_blocks_type][cur_blocks_state][i][j] > 0) {
				return 1;
			}
		}
	}
	return 0;
}
void draw_cur_blocks() {
	int i, j;

	for(i = 0; i < 4; i++) {
		for(j = 0; j < 4; j++) {
			if(blocks[cur_blocks_type][cur_blocks_state][i][j] > 0) {
				mvaddch(MY_TABLE_Y + cur_blocks_y + i, MY_TABLE_X + cur_blocks_x + j, '*');
			} 
		}
	}
}

void clear_cur_blocks() {
	int i, j;

	for(i = 0; i < 4; i++) {
		for(j = 0; j < 4; j++) {
			if(blocks[cur_blocks_type][cur_blocks_state][i][j] > 0) {
				mvaddch(MY_TABLE_Y + cur_blocks_y + i, MY_TABLE_X + cur_blocks_x + j, ' ');
			}
		}
	}
}			

void move_blocks_left() {
	clear_cur_blocks();
	cur_blocks_x--;
	if(check_collision())
		cur_blocks_x++;
	draw_cur_blocks();
}

void move_blocks_right() {
	clear_cur_blocks();
	cur_blocks_x++;
	if(check_collision())
		cur_blocks_x--;
	draw_cur_blocks();
}

void move_blocks_down() {
	clear_cur_blocks();
	cur_blocks_y++;
	if(check_collision()) {
		cur_blocks_y--;
		draw_cur_blocks();
		set_block_to_board();
		check_lines();
		create_random_blocks();
	} else {
		draw_cur_blocks();
	}
}

void move_blocks_down_direct() {
	clear_cur_blocks();
	while(!check_collision())
		cur_blocks_y++;
	cur_blocks_y--;
	draw_cur_blocks();
	set_block_to_board();
	check_lines();
	create_random_blocks();
}

void check_attack() {
	clear_cur_blocks();
	cur_blocks_y++;
	if(check_collision()) {
		cur_blocks_y--;
		draw_cur_blocks();
		set_block_to_board();
		check_lines();
		create_random_blocks();
	} else {
		cur_blocks_y--;
		draw_cur_blocks();
	}

}

void rotate_blocks() {
	clear_cur_blocks();
	if(0 <= cur_blocks_state && cur_blocks_state <= 2) {
		cur_blocks_state++;
		if(check_collision())
			cur_blocks_state--;
	} else {
		cur_blocks_state = 0;
		if(check_collision())
			cur_blocks_state = 3;
	}
	draw_cur_blocks();
}

void set_block_to_board() {
	int i, j;
	
	for(i = 0;i < 4; i++) {
		for(j = 0; j < 4; j++) {
			if(blocks[cur_blocks_type][cur_blocks_state][i][j] > 0)	{
				board[cur_blocks_y + i][cur_blocks_x + j] = blocks[cur_blocks_type][cur_blocks_state][i][j];
			}
		}
	}
}

void draw_board() {
	int i, j;

	for(i = 1; i < MAX_HEIGHT - 1; i++) {
		for(j = 1; j < MAX_WIDTH - 1; j++) {
			if(board[i][j] > 0) {
				mvaddch(MY_TABLE_Y + i, MY_TABLE_X + j, '*');
			} else {
				mvaddch(MY_TABLE_Y + i, MY_TABLE_X + j, ' ');
			}
		}
	}
}


void draw_enemy_board(packet data) {
	int i, j;

	for(i = 1; i < MAX_HEIGHT - 1; i++) {
		for(j = 1; j < MAX_WIDTH - 1; j++) {
			if(data.board[i][j] > 0) {
				mvaddch(ENEMY_TABLE_Y + i, ENEMY_TABLE_X + j, '*');
			} else {
				mvaddch(ENEMY_TABLE_Y + i, ENEMY_TABLE_X + j, ' ');
			}
		}
	}
}
int game_over(int status) {
	int rank;
	
	set_timer(0);
	
	switch(status) {
		case SINGLE_GAMEOVER:
			mvprintw(MY_TABLE_Y + 7, MY_TABLE_X + 4, "Game Over");
			break;
			
		case NETWORK_WIN:
			mvprintw(MY_TABLE_Y + 7, MY_TABLE_X + 6, "Win!");
			mvprintw(ENEMY_TABLE_Y + 7, ENEMY_TABLE_X + 6, "Lose");
			break;

		case NETWORK_LOSE:
			mvprintw(MY_TABLE_Y + 7, MY_TABLE_X + 6, "Lose");
			mvprintw(ENEMY_TABLE_Y + 7, ENEMY_TABLE_X + 6, "Win!");
			break;
		case NETWORK_DRAW:
			mvprintw(MY_TABLE_Y + 7, MY_TABLE_X + 6, "Draw");
			mvprintw(ENEMY_TABLE_Y + 7, ENEMY_TABLE_X + 6, "Draw");
			break;
	}

	while(getch() != '\n');

	if(status == SINGLE_GAMEOVER) {
		echo();
		curs_set(1);
		
		if((rank = check_score_list(score, level)) != -1) {
			put_score_list(rank, score, level);
			show_score_list();
		}

	}
	
	return 0; 
}

void pause_game() {
	int ch;
	
	set_timer(0);

	mvprintw(MY_TABLE_Y + 7,MY_TABLE_X + 3, "Pause Game");
	
	while(1) {
		ch = getch();
		if(ch == 'P' || ch == 'p') {
			set_timer(1);
			break;
		}
		
	}
	draw_board();
	draw_cur_blocks();
}

void check_lines() {
	int i, j, k, sum, deleted_lines = 0;
	const size_t packet_len = sizeof(packet);
	packet data;
	
	for( i = 0; i < MAX_HEIGHT - 1; i++) {
		sum = 0;
		for(j = 1; j < MAX_WIDTH - 1; j++) {
			if(board[i][j] > 0) {
				sum += 1;
			}
		}

		if(sum == MAX_WIDTH - 2) {
			for(k = i;  k > 0; k--) {
				for(j = 1; j < MAX_WIDTH - 1; j++) {
					board[k][j] = board[k - 1][j];
				}
			}
			draw_board();
			deleted_lines++;
		}
	}

	score += level * 50;

	if(deleted_lines > 0) {
		score += (int)(pow(level, 2) * deleted_lines * 50);
		whole_deleted_lines += deleted_lines;
		
		while(whole_deleted_lines > (int)(pow(level, 2) * 3) + 5) {
			level++;
			set_timer(1);
		}
	}

	if(network_game == 1) {
		memset(&data, 0, packet_len);
		data.status = htonl(NETWORK_PLAY);

		switch(deleted_lines) {
			case 2:
			case 3:
				data.attack_lines = htonl(1);
				break;
			case 4:
				data.attack_lines = htonl(3);
				break;
			default:
				data.attack_lines = htonl(0);
		}

		for(i = 0; i < MAX_HEIGHT; i++)
			for(j = 0; j < MAX_WIDTH ; j++) 
				data.board[i][j] = board[i][j];
		
		if(send(sock, &data, packet_len, 0) < 0)
			error_handling("send");			
	}
}

void draw_table() {
	int i, j;
	
	mvprintw(MY_TABLE_Y - 1, MY_TABLE_X, "[My Board]");

	for(i = 0; i < MAX_HEIGHT; i++) {
		for(j = 0; j < MAX_WIDTH; j++) {
			if(i == 0 || i == MAX_HEIGHT - 1)
				if(j == 0 || j == MAX_WIDTH - 1)
					mvaddch(MY_TABLE_Y + i, MY_TABLE_X + j, '+');
				else
					mvaddch(MY_TABLE_Y + i, MY_TABLE_X + j, '-');
			else if(j == 0 || j == MAX_WIDTH - 1)
				mvaddch(MY_TABLE_Y + i, MY_TABLE_X + j, '|');
		}
	}

}

void draw_enemy_table() {
	int i, j;
	
	mvprintw(ENEMY_TABLE_Y - 1, ENEMY_TABLE_X, "[Enemy Board]");

	for(i = 0; i < MAX_HEIGHT; i++) {
		for(j = 0; j < MAX_WIDTH; j++) {
			if(i == 0 || i == MAX_HEIGHT - 1)
				if(j == 0 || j == MAX_WIDTH - 1)
					mvaddch(ENEMY_TABLE_Y + i, ENEMY_TABLE_X + j, '+');
				else
					mvaddch(ENEMY_TABLE_Y + i, ENEMY_TABLE_X + j, '-');
			else if(j == 0 || j == MAX_WIDTH - 1)
				mvaddch(ENEMY_TABLE_Y + i, ENEMY_TABLE_X + j, '|');
		}
	}

}

void draw_info() {
	mvhline(INFO_Y, INFO_X, ' ', 11);
	mvprintw(INFO_Y, INFO_X, "[Level %d]", level);
	mvhline(INFO_Y + 2, INFO_X, ' ', 11);
	mvprintw(INFO_Y + 2, INFO_X, "%d pts", score);
}

void draw_help() {
	mvprintw(HELP_Y, HELP_X, "P: Pause");
	mvprintw(HELP_Y + 1, HELP_X, "R: Restart");
	mvprintw(HELP_Y + 2, HELP_X, "X: Exit");
}

int start_single_game() {
	int ch;
	char *rval;
	struct itimerval val;

	clear();

	rval = get_value(MENU_Y, MENU_X, "Input Your Start Level(Default: 1): ");

	if(is_number(rval)) {
		level = atoi(rval);

		if(level == 0)
			level = DEFAULT_LEVEL;
		else if(level > MAX_LEVEL)
			level = MAX_LEVEL;
	} else
		level = DEFAULT_LEVEL;
	
	start_game = 1; 
	score = 0;

	if(level > 1) 
		whole_deleted_lines = (int)(pow(level - 1, 2) * 3) + 5;
		
	noecho();
	curs_set(0);
	clear();
	init_board();
	draw_table();
	draw_board();
	create_random_blocks();
	preview_blocks();
	draw_info();
	draw_help();
	set_timer(1);
	
	while(1) {
		ch = getch();
		
		if(ch == 'X' || ch == 'x') {
			set_timer(0);
			echo();
			curs_set(1);
			break;
		}
		
		if(ch == 'P'|| ch == 'p') {
			pause_game();
			continue;
		}
			
		switch(ch) {
			case KEY_LEFT:
			move_blocks_left();		
			break;
			
			case KEY_RIGHT:
			move_blocks_right();			
			break;
			
			case KEY_DOWN:
			move_blocks_down();
			break;
			
			case KEY_UP:
			rotate_blocks();
			break;
			
			case ' ':
			move_blocks_down_direct();
			break;

			case 'R':
			case 'r':
			set_timer(0);
			return 1; /*  ,  Ѵ. */
			break;
			
		}
		
		if(start_game == 0) {
			break;
		} else {
			preview_blocks();
			draw_info();
		}
		
	} 
	
	return game_over(SINGLE_GAMEOVER); /*  . */
}

int start_single_game_direct(int start_level) {
	int ch;

	set_signal_handler();
	initscr();
	curs_set(0);
	noecho();
	cbreak();	
	keypad(stdscr, TRUE);	
	srand(time(NULL));
	
	start_game = 1; 
	score = 0;
	level = start_level;

	if(level > 1) 
		whole_deleted_lines = (int)(pow(level - 1, 2) * 3) + 5;
		
	clear();
	init_board();
	draw_table();
	draw_board();
	create_random_blocks();
	preview_blocks();
	draw_info();
	draw_help();
	set_timer(1);
	
	while(1) {
		ch = getch();
		
		if(ch == 'X' || ch == 'x') {
			set_timer(0);
			echo();
			curs_set(1);

			return 0;
		}
		
		if(ch == 'P'|| ch == 'p') {
			pause_game();
			continue;
		}
			
		switch(ch) {
			case KEY_LEFT:
			move_blocks_left();		
			break;
			
			case KEY_RIGHT:
			move_blocks_right();			
			break;
			
			case KEY_DOWN:
			move_blocks_down();
			break;
			
			case KEY_UP:
			rotate_blocks();
			break;
			
			case ' ':
			move_blocks_down_direct();
			break;

			case 'R':
			case 'r':
			set_timer(0);
			return 1; /*  ,  Ѵ. */
			break;
			
		}
		
		if(start_game == 0) {
			break;
		} else {
			preview_blocks();
			draw_info();
		}
		
	} 
	
	return game_over(SINGLE_GAMEOVER); /*  . */
}

char *get_value(int y, int x, char *message) {
	int i;
	int ch;
	static char buf[MAX_BUFFER + 1];
	
	memset(buf, 0, sizeof(buf));
	mvprintw(y, x, "%s", message);

	for(i = 0; i < MAX_BUFFER; i++) {
		if((ch = getch()) == '\n') {
			buf[i] = '\0';
			break;

		}
		
		buf[i] = ch;
	}
	
	return buf;
}

int is_number(char *string) {
	int i;

	if(strlen(string)) {
		for(i = 0; i < strlen(string); i++)
			if(isdigit(string[i]) == 0)
				return 0;
		return 1;
	} else {
		return 0;
	}
}

void error_handling(char *message) {
	int error = errno;
	
	refresh();
	endwin();
	fprintf(stderr, "%s: %s\n", message, strerror(error));
	
	exit(1);
}

void sigalrm_handler(int signal_number) {
	move_blocks_down();
}

void sigint_handler(int signal_number) {
	if(network_game == 0 && start_game == 1) /* Single game. */
		start_game = 0;

	/* Ignore SIGINT signal. */
}

int set_signal_handler() {
	struct sigaction sa;
	
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = 0;
	
	sa.sa_handler = sigalrm_handler;
	
	if(sigaction(SIGALRM, &sa, NULL) < 0) {
		perror("sigaction");
		exit(1);
	}
	
	sa.sa_handler = sigint_handler;
	
	if(sigaction(SIGINT, &sa, NULL) < 0) {
		perror("sigaction");
		exit(1);
	}

	sa.sa_handler = SIG_IGN;
	
	if(sigaction(SIGPIPE, &sa, NULL) < 0) {
		perror("sigaction");
		exit(1);
	}
	
	return 0;
}

int set_timer(int flag) {
	struct itimerval val;
	
	memset(&val, 0, sizeof(val));
	
	if(flag > 0) {
		val.it_interval.tv_usec = (1.0 / level) * 1000000 ;
		val.it_value.tv_usec = (1.0 / level) * 1000000 ;
		setitimer(ITIMER_REAL, &val, NULL);
	} else {
		val.it_interval.tv_usec = 0;
		val.it_value.tv_usec = 0;
		setitimer(ITIMER_REAL, &val, NULL);
	}

	return 0;
}
